#include "RealQuat.h"
#include "Vector2.h"
#include "MCGradient.h"


#define kValueShader100 'sval'
struct ValueShader100PMap
{
	real32 Value;
};

#define kValueShader10000 'scal'
struct ValueShader10000PMap
{
	real32 Value;
};

#define kColorShader 'sclr'
struct ColorShaderPMap
{
	TMCColorRGBA color;
};

#define kEnvironmentShader 'senv'
struct EnvironmentShaderPMap
{
	int32 SPAC;
	real32 AMax;
	real32 AMin;
	real32 AINF;
	boolean AINV;
	real32 SLOP;
	real32 SBLE;
	real32 SINF;
	boolean SINV;
	real32 PITC;
	real32 ORIE;
	real32 OBLE;
	real32 OINF;
};

#define kTextureMapShader 'smap'
struct TextureMapShaderPMap
{
	TMCCountedPtr<IShTextureMap> TMap;
	boolean WHid;
	boolean Alph;
	int32 AMod;
};

#define kNormalMapShader 'nmap'
struct NormalMapShaderPMap
{
	TMCCountedPtr<IShTextureMap> TMap;
	int32 NMod;
	boolean FliX;
	boolean FliY;
	boolean FliZ;
	boolean SwYZ;
};

#define kCheckersShader 'schk'
struct CheckersShaderPMap
{
	int32 SIZH;
	int32 SIZV;
};

#define kWoodShader 'swod'
struct WoodShaderPMap
{
	int32 SEED;
	real32 PERT;
	real32 SPAC;
	real32 BLND;
	int32 DIR;
	int32 CNTR;
	real32 SCAL;
	real32 STEP;
};

#define kWiresShader 'swir'
struct WiresShaderPMap
{
	int32 NBH;
	int32 NBV; 
	real32 DNSH;
	real32 DNSV;
	int32 GS;
};

#define kSpotsShader 'sspt'
struct SpotsShaderPMap
{
	int32 SEED;
	real32 TRSH;
	real32 STEP;
};

#define kUVDomainShader 'UVSh'
struct UVDomainShaderPMap
{
	TMCCountedPtr<IShParameterComponent> GlobalShader;
	TMCCountedPtrArray<IShParameterComponent> UVShaders;
};

#define kFractalNoiseShader 'snoi'
struct FractalNoiseShaderPMap
{
	int32 SEED;
	int32 ALGO;
	boolean INVE;
	int32 SPAC;
	real32 OFFS;
	real32 AMPL;
	real32 SCAL;
	boolean FRAC;
	real32 FREQ;
	real32 STEP;
	real32 XSCA;
	real32 YSCA;
	real32 ZSCA;
	real32 XORI;
	real32 YORI;
	real32 ZORI;
	real32 PHY;
	real32 THET;
	real32 PSY;
};

#define kMarbleShader 'smrb'
struct MarbleShaderPMap
{
	int32 SEED;
	real32 PERT;
	real32 SPAC;
	real32 BLND;
	int32 DIR;
	real32 SCAL;
	int16 GLOB;
	int16 PPCB;
	real32 STEP;
};

#define kJuliaShader 'juli'
struct JuliaShaderPMap
{
	real32 SEDX;
	real32 SEDY;
	real32 FJBT;
	real32 FJBL;
	real32 FJBB;
	real32 FJBR;
	int32 MXIT;
};

#define kMandelbrotShader 'mndl'
struct MandelbrotShaderPMap
{
	real32 FMBT;
	real32 FMBL;
	real32 FMBB;
	real32 FMBR;
	int32 MXIT;
};

#define kGradientShader 'grad'
struct GradientShaderPMap
{
	int32 dire;
	real32 turb;
};

#define kPsychedelicShader 'psyc'
struct PsychedelicShaderPMap
{
	real32 intx;
	real32 inty;
	real32 intz;
	real32 scal;
	real32 nbrs;
	real32 dens;
	real32 phas;
	boolean glob;
};

#define kCellularShader 'fcel'
struct CellularShaderPMap
{
	boolean frac;
	real32 scal;
	int32 seed;
	int16 shap;
	real32 ntst;
	TVector2Template<real32> trnc;
};

#define kSphericalMappingShader 'ssph'
struct SphericalMappingShaderPMap
{
	int32 dire;
	TMatrix33SymQuaternion mapt;
	boolean igno;
	int32 uvid;
	int32 reqs;
	TMCCountedPtrArray<IShParameterComponent> shly;
};

#define kCylindricalMappingShader 'scyl'
struct CylindricalMappingShaderPMap
{
	int32 dire;
	TMatrix33SymQuaternion mapt;
	boolean igno;
	int32 uvid;
	int32 reqs;
	TMCCountedPtrArray<IShParameterComponent> shly;
};

#define kFlatMappingShader 'sbox'
struct FlatMappingShaderPMap
{
	int32 dire;
	TMatrix33SymQuaternion mapt;
	boolean igno;
	int32 uvid;
	int32 reqs;
	TMCCountedPtrArray<IShParameterComponent> shly;
};

#define kParametricMappingShader 'sprm'
struct ParametricMappingShaderPMap
{
	int32 dire;
	TMatrix33SymQuaternion mapt;
	boolean igno;
	int32 uvid;
	int32 reqs;
	TMCCountedPtrArray<IShParameterComponent> shly;
	real32 TrsX;
	real32 TrsY;
	real32 Rota;
};

#define kLayersListShader 'slay'
struct LayersListShaderPMap
{
	TMCCountedPtrArray<IShParameterComponent> shly;
};

#define kBasicLayerShader 'saly'
struct BasicLayerShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Shad;
	TMCCountedPtr<IShParameterComponent> Mask;
	int32 uvid;
	real32 left;
	real32 top;
	real32 rght;
	real32 bott;
};

#define kRectangularLayerShader 'srec'
struct RectangularLayerShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Shad;
	TMCCountedPtr<IShParameterComponent> Mask;
	int32 uvid;
	real32 left;
	real32 top;
	real32 rght;
	real32 bott;
};

#define kPolygonLayerShader 'spol'
struct PolygonLayerShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Shad;
	TMCCountedPtr<IShParameterComponent> Mask;
	int32 uvid;
	real32 left;
	real32 top;
	real32 rght;
	real32 bott;
};

#define kOvalLayerShader 'sova'
struct OvalLayerShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Shad;
	TMCCountedPtr<IShParameterComponent> Mask;
	int32 uvid;
	real32 left;
	real32 top;
	real32 rght;
	real32 bott;
};

#define kRegionLayerShader 'sreg'
struct RegionLayerShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Shad;
	TMCCountedPtr<IShParameterComponent> Mask;
	int32 uvid;
	real32 left;
	real32 top;
	real32 rght;
	real32 bott;
};

#define kMultiChannelShader 'scmp'
struct MultiChannelShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Shc0;
	TMCCountedPtr<IShParameterComponent> Alph;
	TMCCountedPtr<IShParameterComponent> Shc1;
	TMCCountedPtr<IShParameterComponent> Shc2;
	TMCCountedPtr<IShParameterComponent> Shc3;
	TMCCountedPtr<IShParameterComponent> Shc4;
	TMCCountedPtr<IShParameterComponent> Shc5;
	TMCCountedPtr<IShParameterComponent> Shc6;
	TMCCountedPtr<IShParameterComponent> Shc7;
	TMCCountedPtr<IShParameterComponent> Shc8;
	TMCCountedPtr<IShParameterComponent> Shc9;
	real32 ampl;
	boolean hitr;
};

#define kSingleChannelShader 'schn'
struct SingleChannelShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Shc0;
	int32 Chan;
};

#define kAddShader 'sadd'
struct AddShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Sh00;
	TMCCountedPtr<IShParameterComponent> Sh01;
};

#define kSubtractShader 'smin'
struct SubtractShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Sh00;
	TMCCountedPtr<IShParameterComponent> Sh01;
};

#define kMultiplyShader 'smul'
struct MultiplyShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Sh00;
	TMCCountedPtr<IShParameterComponent> Sh01;
};

#define kOverlayShader 'sinc'
struct OverlayShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Sh00;
	TMCCountedPtr<IShParameterComponent> Sh01;
	boolean SWAP;
};

#define kMixerShader 'smix'
struct MixerShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Sh00;
	TMCCountedPtr<IShParameterComponent> Sh01;
	TMCCountedPtr<IShParameterComponent> Sh02;
};

#define kMultiChannelMixerShader 'sgmx'
struct MultiChannelMixerShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Sh00;
	TMCCountedPtr<IShParameterComponent> Sh01;
	TMCCountedPtr<IShParameterComponent> Sh02;
};

#define kColorGradientShader 'clgr'
struct ColorGradientShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Sh00;
	TMCGradient grdt;
};

#define kCurveFilterShader 'curv'
struct CurveFilterShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Sh00;
};

#define kPhongShader 'phog'
struct PhongShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Sh00;
};

#define kShadowCatcherShader 'shwc'
struct ShadowCatcherShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Sh00;
	boolean shad;
	boolean gill;
	boolean caus;
};

#define kAnisotropicShader 'anis'
struct AnisotropicShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Sh00;
	int32 clst;
	real32 angle;
};

#define kReferenceShader 'sref'
struct ReferenceShaderPMap
{
	TMCString255 Name;
};

#define kDisplacementMappingShader 'disp'
struct DisplacementMappingShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Shc0;
	int32 smpl;
	boolean smoo;
	boolean Enab;
	boolean prvw;
	boolean subd;
	int32 adpt;
	real32 ampl;
	real32 ofst;
	real32 angl;
};

#define kSubsurfaceShader 'subs'
struct SubsurfaceShaderPMap
{
	TMCColorRGBA color;
	real32 tran;
	real32 refl;
	real32 ints;
	real32 frnl;
	real32 refr;
	boolean Enab;
	boolean Loca;
};

#define kReflectionShader 'refl'
struct ReflectionShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Sh00;
	int32 maxF;
	real32 maxA;
	boolean eblr;
	int32 Qual;
	real32 blur;
	real32 fsnl;
};

#define kTransparencyShader 'tran'
struct TranspearencyShaderPMap
{
	TMCCountedPtr<IShParameterComponent> Sh01;
	TMCCountedPtr<IShParameterComponent> Sh02;
	int32 maxF;
	real32 maxA;
	real32 fsnl;
	boolean useA;
	real32 absc;
	real32 kdif;
	int32 ISQu;
};

#define kBrickShader 'BRCK'
struct BrickShaderPMap
{
	int32 AXIY;
	int32 AXIX;
	real32 AXIZ;
	boolean AXIW;
	int32 AXAA;
	boolean AXAC;
	int32 SIZH;
	int32 SIZV;
	real32 MORT;
	boolean NOMO;
	boolean CURV;
	int32 ORIE;
};

#define kCautionShader 'CAUT'
struct CautionShaderPMap
{
	int32 AXIX;
	int32 PATT;
	int32 AXAA;
	int32 SIZH;
	int32 PRTN;
	int32 ORIE;
};

#define kElevationShader 'ELEV'
struct ElevationShaderPMap
{
	real32 NBHS;
	real32 NBVS;
	real32 NBWS;
	int16 NBXS;
	int32 SPAC;
	int32 DRTN;
	real32 SCLE;
	real32 HEIG;
	real32 HEBL;
	real32 HEWI;
	int16 SEED;
	real32 SCAL;
	int32 SPCE;
	int32 AXIS;
};

#define kIndexOfRefractionShader 'IORS'
struct IndexOfRefractionShaderPMap
{
	int32 QUIK;
	real32 IORV;
	int32 QPCK;
};

#define kNoiseShader 'NOIS'
struct NoiseShaderPMap
{
	int16 NBHS;
	real32 NBVS;
	real32 SCLE;
	int32 SPAC;
	int16 SEED;
	real32 BRIG;
	real32 SCAL;
	real32 SCLX;
	real32 SCLY;
	real32 SCLZ;
	TVector2Template<real32> MNMX;
	boolean THON;
	real32 THVL;
	int32 SPCE;
};

#define kScanLinesShader 'SCLN'
struct ScanLinesShaderPMap
{
	int16 AXIY;
	int32 AXAA;
	int16 SIZH;
	int32 ORIE;
};

#define kSlopeShader 'Slpe'
struct SlopeShaderPMap
{
	real32 NBHS;
	real32 NBVS;
	real32 NBWS;
	real32 SCLE;
	int16 NBXS;
	int32 SPAC;
	real32 SLOP;
	real32 SLBL;
	real32 SLWI;
	real32 SCAL;
	int16 SEED;
	int32 SPCE;
};

#define kSquaresShader 'SQRS'
struct SquaresShaderPMap
{
	int16 NBHS;
	real32 NBVS;
	real32 SCLE;
	int16 AXIY;
	int16 AXIX;
	boolean AXIZ;
	int16 SEED;
	real32 BRIG;
	real32 THVL;
	int16 SIZH;
	int16 SIZV;
	boolean THON;
	boolean BRCK;
	int32 ORIE;
};

#define kTileShader 'TILE'
struct TileShaderPMap
{
	int16 AXIX;
	int16 AXIY;
	real32 AXIZ;
	boolean AXIW;
	int32 AXAA;
	boolean AXAC;
	int16 SIZH;
	int16 SIZV;
	real32 MORT;
	boolean NOMO;
	boolean CURV;
	boolean EQUA;
	boolean NEGA;
	real32 RADI;
	int32 ORIE;
};

#define kTurbulenceShader 'TURB'
struct TurbulenceShaderPMap
{
	int16 NBHS;
	real32 NBVS;
	real32 SCLE;
	int32 SPAC;
	real32 BRIG;
	real32 SCAL;
	real32 SCLX;
	real32 SCLY;
	real32 SCLZ;
	int16 OCTV;
	TVector2Template<real32> MNMX;
	boolean THON;
	real32 THVL;
	int32 SPCE;
};
